#pragma once

#include <Eigen/Eigen>

void skeleton_extraction(Eigen::MatrixXd& V, Eigen::MatrixXi& F, double contraction_factor, int maxIter);
void find_endpoints(Eigen::MatrixXd& V, Eigen::MatrixXi& F, std::vector<int>* ixEndpoints);
int find_root_point(std::vector<int> ixEndpoints, Eigen::MatrixXd& V, Eigen::MatrixXi& F);
void cleanup_mesh(Eigen::MatrixXd& V, Eigen::MatrixXi& F);
void calculate_U(Eigen::MatrixXd& V, Eigen::MatrixXi& F, int rootPointIndex, Eigen::VectorXd& U, Eigen::VectorXd *pStorePVmin);

// ignore in doxygen, this is just debugging stuff
///@cond IGNORE
template <typename T>
void dump_matrix(const char *label, T &M, const char *fmt = "%8.4f  ");

template <typename T>
void dump_matrix(int minRow, int maxRow, int minCol, int maxCol, const char *label, T &M, const char *fmt);
///@endcond