#version 430 core

layout (location = 0) in vec3 aPos;
layout (location = 1) in vec3 aNormal;
layout (location = 2) in vec2 aUV;

out VertexData {
	vec3 positionWS;
	vec3 normalWS;
	vec2 UV;
} vs_out;

uniform mat4 matM;
uniform mat3 matNormalM;
uniform mat4 matVP;

void main() {
	vs_out.positionWS = vec3(matM * vec4(aPos, 1.0));
	vs_out.normalWS = matNormalM * aNormal;
	vs_out.UV = aUV;
	gl_Position = matVP * vec4(vs_out.positionWS, 1.0f);
}
