#version 430 core

layout (location=0) out vec4 fragColor;

in VertexData {
	vec3 positionVS;
	vec3 normalVS;
} fs_in;

uniform vec3 dirLight_direction_VS = vec3(0,0,-1); // normalized!
uniform float ambientLight = 0.1;
uniform float mat_diffuse  = 0.9;
uniform float mat_specular = 0.5;
uniform float mat_shiny = 20.0;

uniform vec4 color = vec4(1,0,0,0.5);

void main() {
	fragColor = color;

	// normals ok? recheck
	// blinn-phong
	vec3 vL = -dirLight_direction_VS;
	vec3 vV = normalize(-fs_in.positionVS);
	vec3 vH = normalize(vL + vV);
	vec3 vN = normalize(fs_in.normalVS);
	float diff = max(dot(vL, vN), 0);
	float spec = pow(max(dot(vH, vN), 0.0), mat_shiny);
	float illum = ambientLight + diff * mat_diffuse + spec * mat_specular;
	fragColor = vec4(color.rgb * illum, color.a);
	//fragColor = vec4(color.rgb * illum, 1);

	//fragColor = vec4(vL,length(vL));


}
