#version 430 core

layout (location = 0) in vec3 aPos;

out VertexData {
	vec3 positionVS;
	vec3 normalVS;
} vs_out;

uniform mat4 matMVP;
uniform mat4 matMV;
uniform mat3 matNormalMV;

void main() {
	vec3 nrm = normalize(aPos); // sphere is centered at origin -> pos == normal

	vs_out.positionVS = vec3(matMV * vec4(aPos, 1.0));
	vs_out.normalVS = normalize(matNormalMV * nrm);

	gl_Position = matMVP * vec4(aPos, 1.0f);
}
